package tests;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import suicideChess.*;
import suicideChess.Move.NotAValidMoveException;
import suicideChess.Square.NotAValidSquare;

/**
 * @author djib
 * 
 * The purpose of this file is to test the Moves.java class and the BitBoard.java class
 * 
 * $LastChangedDate$
 * $LastChangedRevision$
 * $LastChangedBy$
 */

public class TestMoves {

	public static void main(String[] args) {
		BufferedReader moveInput = new BufferedReader(new InputStreamReader(System.in));
		
		try {
			BitBoardTest bitboard = new BitBoardTest();
			bitboard.display();
			
			/*int playerColor = Piece.WHITE;
			System.out.println("White: ");*/
			
			while (true) {
				try {
					/**
					 * Test of Move and Square class
					 */
					//String move = moveInput.readLine();
					//(new MoveTest(move)).display();
					//System.out.println((new BitBoard().squareToBitboardSquare(new Square(move))));
					//new SquareTest(move).display();
					//System.out.println(new Square(move));
					
					
					/**
					 * Test of the moves
					 * Moves must be displayed in the following form :
					 * PieceLetter move(4lettes) PieceCaptureCode(2digits)
					 * example p e4d5 p
					 * 
					 * Not very convenient but it is for test purposes :-P
					 */
					
					String whatMove= moveInput.readLine();

					if (whatMove.startsWith("quit")) {
						System.out.println("Goodbye!");
						break;
					}
					
					/*
					MoveTest theMove;
					Piece movePiece = new Piece(whatMove.toCharArray()[0],playerColor);
					if (whatMove.length()==6) {
						theMove = new MoveTest(whatMove.substring(2,6),movePiece);
					} else if(whatMove.length()==7){ //promotion
						theMove = new MoveTest(whatMove.substring(2,7),movePiece);
					} else if (whatMove.length()==8){ //capture sans promotion
						Piece capturePiece;
						if (playerColor==Piece.WHITE) {
							capturePiece = new Piece(whatMove.toCharArray()[7],Piece.BLACK);
							theMove = new MoveTest(whatMove.substring(2,6),movePiece,capturePiece);
						} else {
							capturePiece = new Piece(whatMove.toCharArray()[7],Piece.WHITE);
							theMove = new MoveTest(whatMove.substring(2,6),movePiece,capturePiece);
						}
					} else { //capture avec promotion
						Piece capturePiece;
						if (playerColor==Piece.WHITE) {
							capturePiece = new Piece(whatMove.toCharArray()[8],Piece.BLACK);
							theMove = new MoveTest(whatMove.substring(2,7),movePiece,capturePiece);
						} else {
							capturePiece = new Piece(whatMove.toCharArray()[8],Piece.WHITE);
							theMove = new MoveTest(whatMove.substring(2,7),movePiece,capturePiece);
						}							
					}
					*/
					
					MoveTest theMove = new MoveTest(whatMove, bitboard);
					
					theMove.display();
					bitboard.doMove(theMove);
					bitboard.display();
					
					/*if (playerColor == Piece.WHITE) {
						playerColor = Piece.BLACK;
						System.out.println("Black: ");
					} else {
						playerColor = Piece.WHITE;
						System.out.println("White: ");
					}*/
				
					
				} catch (NotAValidMoveException err) {
					System.out.println(err);
					continue;
		        } catch (NotAValidSquare err) {
		        	System.out.println(err);
		        	continue;
		        } catch (Exception err) {
		        	System.out.println(err);
		        	break;
		        }
			}
		} catch (NotAValidSquare e) {
			e.printStackTrace();
		}
	}
}

class MoveTest extends Move {
	public MoveTest(String move, Board board) throws NotAValidMoveException, NotAValidSquare {
		super(move, board);
	}
	
	public MoveTest(String move, Piece pieceToMove) throws NotAValidMoveException, NotAValidSquare {
		super(move, pieceToMove);
	}
	public MoveTest(String move, Piece pieceToMove, Piece pieceToCapture) throws NotAValidMoveException, NotAValidSquare {
		super(move, pieceToMove, pieceToCapture);
	}

	public void display() {
		System.out.println(" ");
		System.out.println("==== Move ====");
		System.out.println("Move:       "+getMovingPiece().getPieceNumber());
		System.out.println("From square:"+fromSquare());
		System.out.println("To square:  "+toSquare());
		System.out.println((isPromotionMove() ? "Promotion:  "+getPromotionPiece().getPieceNumber() : "No Promotion"));
		System.out.println((isCaptureMove() ? "Capture:    "+getCapturedPiece().getPieceNumber() : "No Capture"));
		System.out.println("==============");
		System.out.println(" ");
		System.out.println(" ");
	}
}


/*
class SquareTest extends Square {
	public SquareTest(String square) throws NotAValidSquare {
		super(square);
	}
	public void display() {
		System.out.println(" ");
		System.out.println("==== Square ====");	
		System.out.println("Rank:   "+getRank());
		System.out.println("File:   "+getFile());
		System.out.println("FileNb: "+getFileNb());
		System.out.println("===============");
		System.out.println(" ");
		System.out.println(" ");
	}		
}

*/

class BitBoardTest extends Board {
	public BitBoardTest() throws NotAValidSquare {
		super();
	}

	public void display(){
		for (int file = NB_OF_FILES; file >= 1; file--) {
			System.out.println("+---+---+---+---+---+---+---+---+");
			String display = "| ";
			for (int rank=1; rank <= NB_OF_RANKS; rank++) {
				boolean displayedSomething = false;
				long mask = mapSquaresToBits[rank-1+(file-1)*NB_OF_RANKS];

					if (displayPiece(Piece.BLACK_PAWN,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.PAWN_CHAR)+" | ";
					}
					if (displayPiece(Piece.BLACK_QUEEN,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.QUEEN_CHAR)+" | ";
					}
					if (displayPiece(Piece.BLACK_KING,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.KING_CHAR)+" | ";
					}
					if (displayPiece(Piece.BLACK_KNIGHT,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.KNIGHT_CHAR)+" | ";
					}
					if (displayPiece(Piece.BLACK_ROOK,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.ROOK_CHAR)+" | ";
					}
					if (displayPiece(Piece.BLACK_BISHOP,mask)) {
						displayedSomething=true;
						display+=Character.toUpperCase(Piece.BISHOP_CHAR)+" | ";
					}
					if (displayPiece(Piece.WHITE_PAWN,mask)) {
						displayedSomething=true;
						display+=Piece.PAWN_CHAR+" | ";
					}
					if (displayPiece(Piece.WHITE_QUEEN,mask)) {
						displayedSomething=true;
						display+=Piece.QUEEN_CHAR+" | ";
					}
					if (displayPiece(Piece.WHITE_KING,mask)) {
						displayedSomething=true;
						display+=Piece.KING_CHAR+" | ";
					}
					if (displayPiece(Piece.WHITE_KNIGHT,mask)) {
						displayedSomething=true;
						display+=Piece.KNIGHT_CHAR+" | ";
					}
					if (displayPiece(Piece.WHITE_ROOK,mask)) {
						displayedSomething=true;
						display+=Piece.ROOK_CHAR+" | ";
					}
					if (displayPiece(Piece.WHITE_BISHOP,mask)) {
						displayedSomething=true;
						display+=Piece.BISHOP_CHAR+" | ";
					}
					if (!displayedSomething)
						display+="  | ";
			}
			System.out.println(display);
		}
		System.out.println("+---+---+---+---+---+---+---+---+");
	}
	
	private boolean displayPiece(int whatToDisplay, long mask) {
		if ((bitBoards[whatToDisplay] & mask)==0) {
			return false;
		} else {
			return true; 
		}
	}
	/*
	public void add (Square square, Piece piece) {
		addPiece(square, piece);
	}
	public void rm (Square square, Piece piece) throws NoPieceOnSquare {
		removePiece(square, piece);
	}
	*/
	
}